// CS 106 Winter 2018
// Assignment 07 Question 02
// YOUR NAME
// YOUR STUDENT ID #

// Define a bunch of constants to control the behaviour 
// of the game

// How fast the bird accelerates downward
float gravity = 0.2;
// Width of strip of terrain at top of window
float top_margin = 50.0;
// Width of strip of terrain at bottom of window
float bottom_margin = 100.0;
// How fast the game scrolls horizontally
float scroll_speed = 4.0;
// How much of a heigh boost you get when you're flapping
float flap_speed = 4.0;
// Colour to use for the game background
color sky_colour = color( 150, 150, 255 );
// Colour to use for the "terrain" (floating blobs)
color terrain_colour = color( 60, 100, 60 );

// Load a flappy bird icon to represent the player
PImage bird;

// These global variables define the game state and are likely to
// change every frame.

// The bird's current Y position on the screen
float bird_position;
// The bird's current downward speed (higher speed = falling faster)
float bird_velocity;
// The current amount that the screen has scrolled forward (i.e.,
// how far you've travelled in the game.
float scroll;
// The timestamp of the last time you restarted the game.
int last_restart;
// Your current score, measured as the number of seconds elapsed
// since the last time you restarted.
int score;

// Keep track of whether the player has lost, or the game is
// still running.
boolean game_over;

void setup()
{
  size( 400, 600 );

  bird = loadImage( "bird.png" );
  imageMode( CENTER );

  textSize( 30 );
  textAlign( RIGHT );

  noStroke();

  resetGame();
}

// Do all the things that need to be done to put the game
// into its initial state.
void resetGame()
{
  game_over = false;
  score = 0;
  last_restart = millis();

  // It seems a bit odd to set the scroll to a random number.
  // But later, when we use the noise() function, it'll be offset
  // but this amount, so setting it randomly allows the game to
  // start with new random blobs of terrain.
  scroll = random(1000000);
  bird_velocity = 0.0;
  bird_position = height/2;
}

// Given a pixel in the sketch window, does it belong to terrain
// or to the background?  This can be used to check for the player
// losing.  It can also be used to draw the game if you want.
boolean isTerrain( int x, int y )
{
  if ( y <= top_margin ) {
    return true;
  }
  if ( y >= height - bottom_margin ) {
    return true;
  }

  return false;
}

void draw()
{
  background( sky_colour );
  fill( terrain_colour );

  // Draw the margins at the top and bottom of the sketch.
  rect( 0, 0, width, top_margin );
  rect( 0, height-bottom_margin, width, bottom_margin );
  
  // TODO: draw all other obstacles (i.e., floating blobs of
  // terrain) here.

  // Draw the player.
  image( bird, width/2, bird_position );

  // Write the score to the bottom-right corner.
  fill(255);
  text( "" + score, width - 20, height - 10 );

  // If the game is still running, update it.
  if ( !game_over ) {
    // Update the score.
    score = (millis()-last_restart) / 1000;
    // Scroll the game.
    scroll += scroll_speed;

    if ( keyPressed && (key == ' ') ) {
      // If the player is holding down the space bar, don't
      // apply gravity.  Instead, move them up the screen at 
      // a constant speed.
      bird_position -= flap_speed;
      bird_velocity = 0;
    } else {
      // If the user isn't holding down the space bar, apply
      // gravity to accelerate them downward.
      bird_position += bird_velocity;
      bird_velocity += gravity;
    }

    // Check the player's current position against known terrain
    // locations.  If the player's location is a terrain pixel, 
    // stop the game.
    if ( isTerrain( width / 2, int( bird_position ) ) ) {
      game_over = true;
    }
  }
}

void keyPressed()
{
  // Press the 'r' key to restart the game.
  if ( game_over && (key == 'r') ) {
    resetGame();
  }
}